<?php

namespace Drupal\string_plural_form\Attribute;

use Drupal\Component\Plugin\Attribute\Plugin;
use Drupal\Core\StringTranslation\TranslatableMarkup;

/**
 * The Block attribute.
 */
#[\Attribute(\Attribute::TARGET_CLASS)]
class StringPluralForm extends Plugin {

  /**
   * Constructs "StringPluralForm" attribute.
   *
   * @param string $id
   *   The Plugin ID.
   * @param \Drupal\Core\StringTranslation\TranslatableMarkup|null $admin_label
   *   The administrative label of the Plural Form.
   * @param \Drupal\Core\StringTranslation\TranslatableMarkup|null $description
   *   The administrative description of the Plural Form.
   */
  public function __construct(
    public readonly string $id,
    public readonly TranslatableMarkup $admin_label,
    public readonly TranslatableMarkup $description,
  ) {}

}
