<?php

namespace Drupal\string_plural_form;

use Drupal\Core\Cache\CacheBackendInterface;
use Drupal\Core\Extension\ModuleHandlerInterface;
use Drupal\Core\Plugin\DefaultPluginManager;

/**
 * Plugin manager for "string_plural_form".
 */
class StringPluralFormManager extends DefaultPluginManager {

  public function __construct(
    \Traversable $namespaces,
    CacheBackendInterface $cache_backend,
    ModuleHandlerInterface $module_handler,
  ) {
    parent::__construct(
      'Plugin/StringPluralForm',
      $namespaces,
      $module_handler,
      'Drupal\string_plural_form\StringPluralFormPluginInterface',
      'Drupal\string_plural_form\Attribute\StringPluralForm'
    );
    $this->alterInfo($this->getType());
    $this->setCacheBackend($cache_backend, 'string_plural_form_plugins');
  }

  /**
   * {@inheritdoc}
   */
  protected function getType() {
    return 'string_plural_form';
  }

}
