<?php

namespace Drupal\Tests\string_plural_form\Unit\StringPluralForm;

use Drupal\string_plural_form\Plugin\StringPluralForm\ThreeFormsSpecialCaseForZero;

use Drupal\Tests\UnitTestCase;

/**
 * @coversDefaultClass \Drupal\string_plural_form\Plugin\StringPluralForm\ThreeFormsSpecialCaseForZero
 * @group StringPluralFormPlugins
 */
class ThreeFormsSpecialCaseForZeroTest extends UnitTestCase {

  /**
   * Tests \Drupal\string_plural_form\Plugin\StringPluralForm\ThreeFormsSpecialCaseForZero::getGettextNplurals()
   */
  public function testGetGettextNplurals() {
    $plugin = new ThreeFormsSpecialCaseForZero();
    $this->assertEquals(3, $plugin->getGettextNplurals());
  }

  /**
   * Tests \Drupal\string_plural_form\Plugin\StringPluralForm\ThreeFormsSpecialCaseForZero::getGettextNplurals()
   */
  public function testGetGettextPlural() {
    $plugin = new ThreeFormsSpecialCaseForZero();
    $this->assertEquals("n%10==1 && n%100!=11 ? 0 : n != 0 ? 1 : 2", $plugin->getGettextPlural());
  }

  /**
   * Tests \Drupal\string_plural_form\Plugin\StringPluralForm\ThreeFormsSpecialCaseForZero::getIndex()
   */
  public function testGetIndex() {
    $plugin = new ThreeFormsSpecialCaseForZero();
    $expected_forms = [
      0 => [
        1, 21, 31, 41, 51, 61, 71, 81, 91,
        101, 121, 131, 141, 151, 161, 171, 181, 191,
      ],
      1 => [
        2, 3, 4, 5, 6, 7, 8, 9,
        10, 11, 12, 13, 14, 15, 16, 17, 18, 19,
        20, 22, 23, 24, 25, 26, 27, 28, 29,
        30, 32, 33, 34, 35, 36, 37, 38, 39,
        40, 42, 43, 44, 45, 46, 47, 48, 49,
        50, 52, 53, 54, 55, 56, 57, 58, 59,
        60, 62, 63, 64, 65, 66, 67, 68, 69,
        70, 72, 73, 74, 75, 76, 77, 78, 79,
        80, 82, 83, 84, 85, 86, 87, 88, 89,
        90, 92, 93, 94, 95, 96, 97, 98, 99,
        100, 102, 103, 104, 105, 106, 107, 108, 109,
        110, 111, 112, 113, 114, 115, 116, 117, 118, 119,
        120, 122, 123, 124, 125, 126, 127, 128, 129,
        130, 132, 133, 134, 135, 136, 137, 138, 139,
        140, 142, 143, 144, 145, 146, 147, 148, 149,
        150, 152, 153, 154, 155, 156, 157, 158, 159,
        160, 162, 163, 164, 165, 166, 167, 168, 169,
        170, 172, 173, 174, 175, 176, 177, 178, 179,
        180, 182, 183, 184, 185, 186, 187, 188, 189,
        190, 192, 193, 194, 195, 196, 197, 198, 199,
      ],
      2 => [0],
    ];

    foreach ($expected_forms as $index => $numbers) {
      foreach ($numbers as $n) {
        $this->assertEquals($index, $plugin->getIndex($n));
      }
    }
  }

}
