<?php

namespace Drupal\Tests\string_plural_form\Unit\StringPluralForm;

use Drupal\string_plural_form\Plugin\StringPluralForm\TwoFormsAustronesian;
use Drupal\Tests\UnitTestCase;

/**
 * @coversDefaultClass \Drupal\string_plural_form\Plugin\StringPluralForm\TwoFormsAustronesian
 * @group StringPluralFormPlugins
 */
class TwoFormsAustronesianTest extends UnitTestCase {

  /**
   * Tests \Drupal\string_plural_form\Plugin\StringPluralForm\TwoFormsAustronesian::getGettextNplurals()
   */
  public function testGetGettextNplurals() {
    $plugin = new TwoFormsAustronesian();
    $this->assertEquals(2, $plugin->getGettextNplurals());
  }

  /**
   * Tests \Drupal\string_plural_form\Plugin\StringPluralForm\TwoFormsAustronesian::getGettextNplurals()
   */
  public function testGetGettextPlural() {
    $plugin = new TwoFormsAustronesian();
    $this->assertEquals("n != 1 && n != 2 && n != 3 && (n % 10 == 4 || n % 10 == 6 || n % 10 == 9)", $plugin->getGettextPlural());
  }

  /**
   * Tests \Drupal\string_plural_form\Plugin\StringPluralForm\TwoFormsAustronesian::getIndex()
   */
  public function testGetIndex() {

    $plugin = new TwoFormsAustronesian();

    $expected_forms = [
      0 => [
        0, 1, 2, 3, 5, 7, 8,
        10, 11, 12, 13, 15, 17, 18,
        20, 21, 22, 23, 25, 27, 28,
        30, 31, 32, 33, 35, 37, 38,
        40, 41, 42, 43, 45, 47, 48,
        50, 51, 52, 53, 55, 57, 58,
        60, 61, 62, 63, 65, 67, 68,
        70, 71, 72, 73, 75, 77, 78,
        80, 81, 82, 83, 85, 87, 88,
        90, 91, 92, 93, 95, 97, 98,
        100, 101, 102, 103, 105, 107, 108,
        110, 111, 112, 113, 115, 117, 118,
        120, 121, 122, 123, 125, 127, 128,
        130, 131, 132, 133, 135, 137, 138,
        140, 141, 142, 143, 145, 147, 148,
        150, 151, 152, 153, 155, 157, 158,
        160, 161, 162, 163, 165, 167, 168,
        170, 171, 172, 173, 175, 177, 178,
        180, 181, 182, 183, 185, 187, 188,
        190, 191, 192, 193, 195, 197, 198,
      ],
      1 => [
        4, 6, 9,
        14, 16, 19,
        24, 26, 29,
        34, 36, 39,
        44, 46, 49,
        54, 56, 59,
        64, 66, 69,
        74, 76, 79,
        84, 86, 89,
        94, 96, 99,
        104, 106, 109,
        114, 116, 119,
        124, 126, 129,
        134, 136, 139,
        144, 146, 149,
        154, 156, 159,
        164, 166, 169,
        174, 176, 179,
        184, 186, 189,
        194, 196, 199,
      ],
    ];

    foreach ($expected_forms as $index => $numbers) {
      foreach ($numbers as $n) {
        $this->assertEquals($index, $plugin->getIndex($n));
      }
    }
  }

}
